//
//  SubController.swift
//  SelectorMatchingBug
//
//  Created by Hagi on 14/07/16.
//  Copyright © 2016 iosphere GmbH. All rights reserved.
//

import UIKit

class SubController: BaseController, UITableViewDataSource /*, UITableViewDelegate */ {

    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 10
    }

    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = UITableViewCell(style: .default, reuseIdentifier: nil)
        cell.textLabel?.text = "\(indexPath.row + 1)"
        return cell
    }

    func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        return true
    }

    func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        // do nothing here...
    }

    // MARK: - Please focus on this one

    // This is what the below method should read like:
    /*
    func tableView(_ tableView: UITableView, editingStyleForRowAt indexPath: IndexPath) -> UITableViewCellEditingStyle {
        return .delete
    }
     */

    // This is what the method reads after an incomplete migration (note the second parameter name):
    func tableView(_ tableView: UITableView, editingStyleForRowAtIndexPath indexPath: IndexPath) -> UITableViewCellEditingStyle {
        /*
         While this method is called at runtime (surprisingly), the selector does not really match (see correct declaration above).

         If you remove the UITableViewDelegate declaration from BaseController and add it to this class directly (just remove the comment in line 11), the compiler throws an error (as expected).
         */

        return .delete
    }

}
